# 1 "xio.c"
# 1 "/usr/include/stdio.h"
# 5 "/usr/include/stdio.h"
typedef unsigned size_t;
typedef unsigned fpos_t;	
typedef struct __file_s {
	int	_cnt;
	unsigned char	*_ptr;
	unsigned char	*_base;
	char	_flag;
	char	_file;
} FILE;
extern unsigned char *	_bufendtab[];
# 109 "/usr/include/stdio.h"
extern FILE	_iob[	100];
extern FILE *	tmpfile(void);
extern char *	tmpnam(char *);
extern int	fclose(FILE *);
extern int	fflush(FILE *);
extern FILE *	fopen(const char *, const char *);
extern FILE *	freopen(const char *, const char *, FILE *);
extern void	setbuf(FILE *, char *);
extern int	setvbuf(FILE *, char *, int, size_t);
extern int	fprintf(FILE *, const char *, ...);
extern int	fscanf(FILE *, const char *, ...);
extern int	printf(const char *, ...);
extern int	scanf(const char *, ...);
extern int	sprintf(char *, const char *, ...);
extern int	sscanf(const char *, const char *, ...);
extern int	vfprintf(FILE *, const char *,  char *);
extern int	vprintf(const char *,  char *);
extern int	vsprintf(char *, const char *,  char *);
extern int	fgetc(FILE *);
extern char *	fgets(char *, int, FILE *);
extern int	fputc(int, FILE *);
extern int	fputs(const char *, FILE *);
extern char *	gets(char *);
extern int	puts(const char *);
extern int	ungetc(int, FILE *);
extern size_t	fread(void * , size_t , size_t , FILE *);
extern size_t	fwrite(const void *, size_t, size_t, FILE *);
extern int	fseek(FILE *, long int, int);
extern long int	ftell(FILE *);
extern void	rewind(FILE *);
extern void	perror(const char *);
extern int	_flsbuf(unsigned,FILE*);
extern int	_filbuf(FILE*);
extern int	getc(FILE *);
extern int 	getchar(void);
extern int 	putc(int, FILE *);
extern int	putchar(int);
extern int	_semputc(int, FILE *);
extern int	_semgetc(FILE *);
extern int	feof(FILE *);
extern int	ferror(FILE *);
extern void	clearerr(FILE *);
extern int	fgetpos(FILE *, fpos_t *);
extern int	fsetpos(FILE *, const fpos_t *);
extern char *	_mktemp(char *);
extern int	_fileno(FILE *);
# 200 "/usr/include/stdio.h"
extern void *_sproced;
extern int _us_rsthread_stdio;
# 224 "/usr/include/stdio.h"
# 227 "/usr/include/stdio.h"
extern FILE *	fdopen(int, const char *);
extern FILE *	popen(const char *, const char *);
extern char *	ctermid(char *);
extern char *	cuserid(char *);
extern int	pclose(FILE *);
extern int	system(const char *);	
extern char *	tempnam(const char *, const char *);
extern char *	mktemp(char *);
extern int	mkstemp(char *);
extern int	getw(FILE *);
extern int	putw(int, FILE *);
extern int	setbuffer(FILE *, char *, int);
extern int	setlinebuf(FILE *);
# 269 "/usr/include/stdio.h"
# 273 "/usr/include/stdio.h"
# 95 "xio.c"
# 1 "/usr/include/string.h"
# 5 "/usr/include/string.h"
# 38 "/usr/include/string.h"
# 43 "/usr/include/string.h"
extern char *	strcpy(char *, const char *);
extern char *	strncpy(char *, const char *, size_t);
extern char *	strcat(char *, const char *);
extern char *	strncat(char *, const char *, size_t);
extern void *	memcpy(void *, const void *, size_t);
extern int	memcmp(const void *, const void *, size_t);
extern void *	memchr(const void *, int, size_t);
extern void *	memset(void *, int, size_t);
extern int	strcmp(const char *, const char *);
extern int	strncmp(const char *, const char *, size_t);
extern char *	strchr(const char *, int);
extern size_t	strcspn(const char *, const char *);
extern char *	strpbrk(const char *, const char *);
extern char *	strrchr(const char *, int);
extern size_t	strspn(const char *, const char *);
extern char *	strstr(const char *, const char *);
extern char *	strtok(char *, const char *);
extern size_t	strlen(const char *);
extern char *	strerror(int);
extern void *	memmove(void *, const void *, size_t);
extern int	strcoll(const char *, const char *);
extern size_t	strxfrm(char *, const char *, size_t);
extern char *	strdup(const char *);
extern void *	memccpy(void *, const void *, int, int);
extern int	strcasecmp(const char *, const char *);
extern int	strncasecmp(const char *, const char *, size_t);
# 82 "/usr/include/string.h"
# 96 "xio.c"
# 99 "xio.c"
# 104 "xio.c"
# 109 "xio.c"
# 129 "xio.c"
# 137 "xio.c"
# 152 "xio.c"
typedef int*	FINT;
typedef char*	FCHAR;
static FILE* fp_table[] =
{
	 	(&_iob[2]), (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0,
	  	(&_iob[0]),      	(&_iob[1]), (FILE*)0, (FILE*)0, (FILE*)0,
    (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0,
    (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0,
    (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0,
    (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0,
    (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0,
    (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0,
    (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0,
    (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0,
    (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0,
    (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0,
    (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0,
    (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0,
    (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0,
    (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0,
    (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0,
    (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0,
    (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0,
    (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0, (FILE*)0,
};
static char* filename_table[] =
{
    "/dev/stderr", (char*)0,   (char*)0,   (char*)0,   (char*)0,
    "/dev/stdin",  "/dev/stdout", (char*)0,   (char*)0,   (char*)0,
    (char*)0,   (char*)0,   (char*)0,   (char*)0,   (char*)0,
    (char*)0,   (char*)0,   (char*)0,   (char*)0,   (char*)0,
    (char*)0,   (char*)0,   (char*)0,   (char*)0,   (char*)0,
    (char*)0,   (char*)0,   (char*)0,   (char*)0,   (char*)0,
    (char*)0,   (char*)0,   (char*)0,   (char*)0,   (char*)0,
    (char*)0,   (char*)0,   (char*)0,   (char*)0,   (char*)0,
    (char*)0,   (char*)0,   (char*)0,   (char*)0,   (char*)0,
    (char*)0,   (char*)0,   (char*)0,   (char*)0,   (char*)0,
    (char*)0,   (char*)0,   (char*)0,   (char*)0,   (char*)0,
    (char*)0,   (char*)0,   (char*)0,   (char*)0,   (char*)0,
    (char*)0,   (char*)0,   (char*)0,   (char*)0,   (char*)0,
    (char*)0,   (char*)0,   (char*)0,   (char*)0,   (char*)0,
    (char*)0,   (char*)0,   (char*)0,   (char*)0,   (char*)0,
    (char*)0,   (char*)0,   (char*)0,   (char*)0,   (char*)0,
    (char*)0,   (char*)0,   (char*)0,   (char*)0,   (char*)0,
    (char*)0,   (char*)0,   (char*)0,   (char*)0,   (char*)0,
    (char*)0,   (char*)0,   (char*)0,   (char*)0,   (char*)0,
    (char*)0,   (char*)0,   (char*)0,   (char*)0,   (char*)0,
};
# 249 "xio.c"
static void
FtoC(f,nf)			
char *f;			
int nf;
{
    char *p;
    p = &f[nf-1];
    while ((*p == ' ') && (p > f))
	--p;
    p[1] = '\0';		
}
static void
CtoF(c)				
char *c;			
{				
    char *p;
    p = strchr(c,'\0');
    *p = ' ';
}
void
xclear_(u)
FINT u;				
{
    if (	(		((0 <= 	*u		) && (	*u		 < 		(sizeof(fp_table)/sizeof(fp_table[0])))) && 		(			fp_table[	*u		] != (FILE*)0)))
		((void) ((			fp_table[	*u		])->_flag &= ~(	0040 | 	0020)));
}
int
xclose_(u)			
FINT u;				
{
    int code;
    if (		((0 <= 	*u		) && (	*u		 < 		(sizeof(fp_table)/sizeof(fp_table[0])))))
    {
	if (		(			fp_table[	*u		] != (FILE*)0))
	{
	    code = fclose(			fp_table[	*u		]);	
	    filename_table[	*u		] = (char*)0; 
	    			fp_table[	*u		] = (FILE*)0;
	}
	else
	    code = 0;		
    }
    else			
	code = (-1)		;
    return ((code == 0) ? 	*u		 : (-1)		);
}
int
xeof_(u)
FINT u;				
{
    if (	(		((0 <= 	*u		) && (	*u		 < 		(sizeof(fp_table)/sizeof(fp_table[0])))) && 		(			fp_table[	*u		] != (FILE*)0)))
	return (		((			fp_table[	*u		])->_flag & 	0020));
    else
	return (0);
}
int
xerr_(u)
FINT u;				
{
    if (	(		((0 <= 	*u		) && (	*u		 < 		(sizeof(fp_table)/sizeof(fp_table[0])))) && 		(			fp_table[	*u		] != (FILE*)0)))
	return (	((			fp_table[	*u		])->_flag & 	0040));
    else
	return (0);
}
int
xfilno_(u)
FINT u;				
{
    if (	(		((0 <= 	*u		) && (	*u		 < 		(sizeof(fp_table)/sizeof(fp_table[0])))) && 		(			fp_table[	*u		] != (FILE*)0)))
	return (	(			fp_table[	*u		])->_file);
    else
	return (-1);
}
int
xflush_(u)
FINT u;
{
    if (	(		((0 <= 	*u		) && (	*u		 < 		(sizeof(fp_table)/sizeof(fp_table[0])))) && 		(			fp_table[	*u		] != (FILE*)0)))
	return ((fflush(			fp_table[	*u		]) < 0) ? (-1)		 : 	*u		);
    else
	return ((-1)		);		
}
# 370 "xio.c"
int
xfname_(u, filename,   filename_len	)
FINT u;
FCHAR filename;
int   filename_len	;
{
    int n;
    (void)memset(&	filename[0]		, ' ', 	 filename_len	);
    if (	(		((0 <= 	*u		) && (	*u		 < 		(sizeof(fp_table)/sizeof(fp_table[0])))) && 		(			fp_table[	*u		] != (FILE*)0)))
    {
	n = strlen(filename_table[	*u		]);
	(void)strncpy(&	filename[0]		, filename_table[	*u		], 
	    		( ((	 filename_len	) < (n)) ? (	 filename_len	) : (n) ));
		filename[	 filename_len	-1]		 = '\0';
	CtoF(&	filename[0]		);
		filename[	 filename_len	-1]		 = ' ';
	return (	*u		);
    }
    else
	return ((-1)		);		
}
int
xgetc_(u,c)		
FINT u;				
FCHAR c;
{
    int ch;
    if (	(		((0 <= 	*u		) && (	*u		 < 		(sizeof(fp_table)/sizeof(fp_table[0])))) && 		(			fp_table[	*u		] != (FILE*)0)))
	ch = 		( _us_rsthread_stdio ? _semgetc(			fp_table[	*u		]) : 			((--(			fp_table[	*u		])->_cnt > 0 || 	     		(((			fp_table[	*u		])->_cnt == 0 ) && ((			fp_table[	*u		])->_ptr != (			fp_table[	*u		])->_base)))?			(int) *(			fp_table[	*u		])->_ptr++:			((			fp_table[	*u		])->_cnt == 0 ? (int) *(			fp_table[	*u		])->_ptr:_filbuf(			fp_table[	*u		]))));
    else
	ch = (-1)		;
    	c[0]		 = ch;
    return (ch);
}
int
xistty_(u)
FINT u;
{
    return ( (		((0 <= 	*u		) && (	*u		 < 		(sizeof(fp_table)/sizeof(fp_table[0])))) && (isatty(	(			fp_table[	*u		])->_file) == 1)) ? 0 : (-1)		 );
}
# 425 "xio.c"
# 429 "xio.c"
int				
xopen_(u,filename,mode,   filename_len	,  mode_len	)
FINT u;				
FCHAR filename;			
FCHAR mode;			
int   filename_len	;		
int   mode_len	;		
{
    if (		((0 <= 	*u		) && (	*u		 < 		(sizeof(fp_table)/sizeof(fp_table[0])))))
    {
	FtoC(&	filename[0]		,	 filename_len	);
	FtoC(&	mode[0]		,	 mode_len	);
				fp_table[	*u		] = fopen(&	filename[0]		,&	mode[0]		);
	if (		(			fp_table[	*u		] != (FILE*)0))
	{			
	    filename_table[	*u		] = (char*)malloc(strlen(&	filename[0]		)+1);
	    if (filename_table[	*u		] != (char*)0)
		(void)strcpy(filename_table[	*u		],&	filename[0]		);
	}
	CtoF(&	filename[0]		);
	CtoF(&	mode[0]		);
	return (		(			fp_table[	*u		] != (FILE*)0) ? 	*u		 : (-1)		);
    }
    else
	return ((-1)		);
}
int
xputb_(u,c)			
FINT u;				
FINT c;				
{
    if (	(		((0 <= 	*u		) && (	*u		 < 		(sizeof(fp_table)/sizeof(fp_table[0])))) && 		(			fp_table[	*u		] != (FILE*)0)))
    {
		( _us_rsthread_stdio ? _semputc(	*c		,			fp_table[	*u		]) : 			(--(			fp_table[	*u		])->_cnt < 0 ? _flsbuf((unsigned char) (	*c		), (			fp_table[	*u		])) : 			(int) (*(			fp_table[	*u		])->_ptr++ = (unsigned char) (	*c		))));
	return (	*u		);
    }
    else
	return ((-1)		);
}
int
xputc_(u,c)			
FINT u;				
FCHAR c;			
{
    if (	(		((0 <= 	*u		) && (	*u		 < 		(sizeof(fp_table)/sizeof(fp_table[0])))) && 		(			fp_table[	*u		] != (FILE*)0)))
    {
		( _us_rsthread_stdio ? _semputc(	c[0]		,			fp_table[	*u		]) : 			(--(			fp_table[	*u		])->_cnt < 0 ? _flsbuf((unsigned char) (	c[0]		), (			fp_table[	*u		])) : 			(int) (*(			fp_table[	*u		])->_ptr++ = (unsigned char) (	c[0]		))));
	return (	*u		);
    }
    else
	return ((-1)		);
}
int
xputh_(u,h,nh)			
FINT u;				
char *h;			
FINT nh;			
{
    int code;
    char c;
    if (	(		((0 <= 	*u		) && (	*u		 < 		(sizeof(fp_table)/sizeof(fp_table[0])))) && 		(			fp_table[	*u		] != (FILE*)0)))
    {
	c = h[	*nh		];
	h[	*nh		] = '\0';
	code = fputs(h,			fp_table[	*u		]);
	h[	*nh		] = c;
	return ((code < 0) ? (-1)		 : 	*u		);
    }
    else
	return ((-1)		);
}
# 516 "xio.c"
int
xputs_(u,s,  s_len	)		
FINT u;				
FCHAR s;			
int   s_len	;				
{
    int code;
    char c;
    if (	(		((0 <= 	*u		) && (	*u		 < 		(sizeof(fp_table)/sizeof(fp_table[0])))) && 		(			fp_table[	*u		] != (FILE*)0)))
    {
	c = 	s[	 s_len	]		;
		s[	 s_len	]		 = '\0';
	code = fputs(&	s[0]		,			fp_table[	*u		]);
		s[	 s_len	]		 = c;
	return ((code < 0) ? (-1)		 : 	*u		);
    }
    else
	return ((-1)		);
}
int
xunit_()			
{
    int u;
    for (u = (		(sizeof(fp_table)/sizeof(fp_table[0])) - 1); u >= 0; --u)
    {
	if (!		(			fp_table[	*&u		] != (FILE*)0))
	    return (u);
    }
    return ((-1)		);    
}
