      SUBROUTINE  DOCYCL (INDX)
C     (Do CYCLE)
C     (23-OCT-84)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHPRCY,      GIFLOG,      GOTOS2,      OSFLST
C     EXTERNAL REFS       SFTERR
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                L,           TWORD
C
      INTEGER             INDX,        L,           TWORD
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM01  /
C
      INTEGER             BYTE,        CC,          CCLABL
      INTEGER             CCMORE,      IN,          INDENT
      INTEGER             LLABL,       MLABL
      INTEGER             NHELD,       OUT
      INTEGER             UNDENT
      LOGICAL             EOF,         FIRST,       LABEL,       LAST
      LOGICAL             MORE
C
      COMMON / COM01  /   BYTE,        CC,          CCLABL
      COMMON / COM01  /   CCMORE,      EOF,         FIRST,       IN
      COMMON / COM01  /   INDENT,      LABEL,       LAST
      COMMON / COM01  /   LLABL,       MLABL,       MORE
      COMMON / COM01  /   NHELD
      COMMON / COM01  /   OUT,         UNDENT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM03  /
C
      INTEGER             CASES,       CCINDX,      CCLOG,       CCLOGS
      INTEGER             LINDX,       LLOG
      INTEGER             MINDX,       NFND,        NONE
      INTEGER             NSTACK,      S1STAK,      SFNMBR
      LOGICAL             BLANK,       FOUND,       NOFLOW,      NONMBR
      LOGICAL             XLATED
C
      COMMON / COM03  /   BLANK,       CASES(39),   CCINDX,      CCLOG
      COMMON / COM03  /   CCLOGS(2),   FOUND,       LINDX
      COMMON / COM03  /   LLOG,        MINDX
      COMMON / COM03  /   NFND,        NOFLOW,      NONE,        NONMBR
      COMMON / COM03  /   NSTACK,      S1STAK(39),  SFNMBR
      COMMON / COM03  /   XLATED
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM05  /
C
      INTEGER             BLANKS,      LEFT,        LEVEL
      INTEGER             RIGHT,       S0,          S1,          STRCTS
      COMMON / COM05  /   BLANKS(92),  LEFT,        LEVEL
      COMMON / COM05  /   RIGHT,       S0,          S1
      COMMON / COM05  /   STRCTS(39)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM07  /
C
      INTEGER             S1PNDG,      S2
      LOGICAL             EXITS,       FND,         OTHERS
C
      COMMON / COM07  /   EXITS(39),   FND,         OTHERS(39),  S1PNDG
      COMMON / COM07  /   S2
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM08  /
C
      LOGICAL             CYCLES
C
      COMMON / COM08  /   CYCLES(39)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM25  /
C
      INTEGER             DEFINE,      DOCASE,      DOFOR,       DOWITH
      INTEGER             ELSEIF,      FOREVR,      IFELSE,      IFTHEN
      INTEGER             ONCE,        PROC,        UNTIL,       WHILE
C
      COMMON / COM25  /   DEFINE,      DOCASE,      DOFOR,       DOWITH
      COMMON / COM25  /   ELSEIF,      FOREVR,      IFELSE,      IFTHEN
      COMMON / COM25  /   ONCE,        PROC,        UNTIL,       WHILE
C
C
      ASSIGN 20001 TO NPR001
      GO TO 30001
20001 IF (.NOT.(FND)) GO TO 20002
      CYCLES(NSTACK)=.TRUE.
      UNDENT=LEVEL-NSTACK+1
      ASSIGN 20005 TO NPR002
      GO TO 30002
20005 GO TO 20007
20006 IF (FND .OR. NSTACK.EQ.0) GO TO 20008
20007 TWORD=STRCTS(NSTACK)
      FND=TWORD.EQ.DOFOR .OR. TWORD.EQ.WHILE .OR.
     XTWORD.EQ.UNTIL .OR. TWORD.EQ.FOREVR
      IF (.NOT.FND) NSTACK=NSTACK-1
      GO TO 20006
20008 IF (.NOT.(FND)) GO TO 20009
      IF (.NOT.(TWORD.EQ.DOFOR)) GO TO 20012
      L=-2
      GO TO 20013
20012 IF (.NOT.(TWORD.EQ.WHILE .OR. TWORD.EQ.UNTIL .OR.
     XTWORD.EQ.FOREVR)) GO TO 10001
      L=0
10001 CONTINUE
20013 CONTINUE
20014 S2=S1STAK(NSTACK)+L
      NX0017=INDX
      IF (NX0017.LT.1.OR.NX0017.GT.2) GO TO 20017
      GO TO (20015,20016), NX0017
20015 ASSIGN 20019 TO NPR003
      GO TO 30003
20019 GO TO 20018
20016 S1=0
      ASSIGN 20020 TO NPR004
      GO TO 30004
20020 CONTINUE
20017 CONTINUE
20018 GO TO 20010
20009 CALL SFTERR(1,32H(Illegal CYCLE attempt. Ignored))
20010 CONTINUE
20002 CONTINUE
C
20003 RETURN
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Check If Proper CYCLE Was Found)
30001 CALL CHPRCY
      GO TO 20001
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate 'GO TO S2')
30003 CALL GOTOS2
      GO TO 20019
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate 'S1 IF (Logic) GO TO S2')
30004 CALL GIFLOG
      GO TO 20020
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Output SFTRAN Statement To List File)
30002 CALL OSFLST
      GO TO 20005
C
      END
