C-fpp- =================================================================
C-fpp- fpp -- C version 1.0.1 [08-Feb-1991]
C-fpp- Date: Sat Feb 16 12:48:01 1991
C-fpp- Directory: /u/plot79/sf3dir
C-fpp- User: Nelson H. F. Beebe <beebe>
C-fpp- Macro: _OS_UNIX=1
C-fpp- Macro: _AIX=1
C-fpp- Macro: _IBM_RS_6000=1
C-fpp- Macro: _BIG_ENDIAN=1
C-fpp- =================================================================
      BLOCK DATA
C     (Block Data)
C     This BLOCK  DATA routine  initializes constants  stored  in
C     COMMON blocks  used by  the SFTRAN/3  preprocessor.  It  is
C     imperative  that it  be  loaded  when the  preprocessor  is
C     re-linked.   On most  machines, this  will require explicit
C     action on  the  part of  the installer,  because  automatic
C     library call will usually not cause its retrieval since the
C     global   COMMON   block  names   are   defined   in   other
C     already-loaded routines.
C
C     When the SFTRAN/3 preprocessor  is to be installed on a new
C     machine,  certain dimension statements of  arrays in COMMON
C     must  be revised, and certain  symbolic constants must also
C     be updated.  These are as follows:
C
C     Constant definitions:
C
C     MAXBUF----Maximum   number  of  characters   in  a  FORTRAN
C               statement.   This is 1326 =  72 + 19*66, allowing
C               for  the  standard  maximum  of  19  continuation
C               lines.
C
C     MAXCOR----Dimension of CORE(*) (used only in COREIO).
C
C     MAXLAB----Dimension of LABELS(*).
C
C     MAXOUT----Maximum number of  columns in the output SFTRAN/3
C               structured listing.
C
C     MAXTAB----Dimension of NAMTAB(*).
C
C     MCALLS----Dimension of SCALLS(*) and NAMNOS(*).
C
C     MNAMES----Dimension  of LNAMES(*),  USES(*), DEFS(*), and
C               LINES(2,*).
C
C     WDSIZE----Number  of characters which can  be packed into a
C               single integer storage unit.
C
C     Let WDS(NCHARS) =  1 + (NCHARS-1)/WDSIZE  be the number  of
C     integer  storage  units  required  to  hold  NCHARS  packed
C     characters.  Arrays which  hold packed  characters must  be
C     dimensioned as follows:
C
C     ALIGN(WDS(MAXOUT/2))
C     BLANKS(WDS(92))
C     BUFFER(WDS(MAXBUF))
C     STMT(WDS(MAXBUF))
C
C     Finally, the statement function "NWDSF" which is defined in
C     the portable INCLUDE  file must be  updated to reflect  the
C     number of characters/word.
C
C     (16-Feb-1991)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM01  /
C
      INTEGER             BYTE,        CC,          CCLABL
      INTEGER             CCMORE,      IN,          INDENT
      INTEGER             LLABL,       MLABL
      INTEGER             NHELD,       OUT
      INTEGER             UNDENT
      LOGICAL             EOF,         FIRST,       LABEL,       LAST
      LOGICAL             MORE
C
      COMMON / COM01  /   BYTE,        CC,          CCLABL
      COMMON / COM01  /   CCMORE,      EOF,         FIRST,       IN
      COMMON / COM01  /   INDENT,      LABEL,       LAST
      COMMON / COM01  /   LLABL,       MLABL,       MORE
      COMMON / COM01  /   NHELD
      COMMON / COM01  /   OUT,         UNDENT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM02  /
C
      INTEGER             CCFLGS,      CCLIST,      CCNAME,      CCRW
      INTEGER             DEFNO,       INDEXS,      LFLGS,       LLIST
      INTEGER             LLOGS,       MAXLEV,      NEXT
C
      COMMON / COM02  /   CCFLGS(2),   CCLIST,      CCNAME,      CCRW
      COMMON / COM02  /   DEFNO,       INDEXS(38,39)
      COMMON / COM02  /   LFLGS(2),    LLIST,       LLOGS(2)
      COMMON / COM02  /   MAXLEV,      NEXT
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM03  /
C
      INTEGER             CASES,       CCINDX,      CCLOG,       CCLOGS
      INTEGER             LINDX,       LLOG
      INTEGER             MINDX,       NFND,        NONE
      INTEGER             NSTACK,      S1STAK,      SFNMBR
      LOGICAL             BLANK,       FOUND,       NOFLOW,      NONMBR
      LOGICAL             XLATED
C
      COMMON / COM03  /   BLANK,       CASES(39),   CCINDX,      CCLOG
      COMMON / COM03  /   CCLOGS(2),   FOUND,       LINDX
      COMMON / COM03  /   LLOG,        MINDX
      COMMON / COM03  /   NFND,        NOFLOW,      NONE,        NONMBR
      COMMON / COM03  /   NSTACK,      S1STAK(39),  SFNMBR
      COMMON / COM03  /   XLATED
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM06  /
C
      INTEGER             F4KEY,       HOLDIO,      INSF,        LINE
      INTEGER             LINENO,      MAXIN,       MDATA,       OUTERR
      INTEGER             OUTF4,       OUTSF,       P2BASE,      PBASE
      INTEGER             SBASE,       SFKEY,       SPACES,      TEMPF4
      LOGICAL             ERRORS
      COMMON / COM06  /   ERRORS,      F4KEY,       HOLDIO,      INSF
      COMMON / COM06  /   LINE,        LINENO,      MAXIN,       MDATA
      COMMON / COM06  /   OUTERR,      OUTF4,       OUTSF,       P2BASE
      COMMON / COM06  /   PBASE,       SBASE,       SFKEY,       SPACES
      COMMON / COM06  /   TEMPF4
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM10  /
C
      INTEGER             L0,          L1STAK,      LBASE
C
      COMMON / COM10  /   L0,          L1STAK(39),  LBASE
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM12  /
C
      INTEGER             ALIGN,       LNUPCH,      MAXOUT,      STETCH
      LOGICAL             COMMNT,      DRECTV,      EXEMPT,      LINEUP
      LOGICAL             NONDNT,      STET
C
      COMMON / COM12  /   ALIGN(120),  COMMNT,      DRECTV,      EXEMPT
      COMMON / COM12  /   LINEUP,      LNUPCH(1),   MAXOUT,      NONDNT
      COMMON / COM12  /   STET,        STETCH(1)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM14  /
C
      INTEGER             WDSIZE
C
      COMMON / COM14  /   WDSIZE
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM15  /
C
      INTEGER             ININCL,      INSFSV,      MCOUNT
      COMMON / COM15  /   ININCL,      INSFSV,      MCOUNT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM17  /
C
      INTEGER             ERROUT,      F4OUT,       INPUT,       SFOUT
C
      COMMON / COM17  /   ERROUT,      F4OUT,       INPUT,       SFOUT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM22  /
C
      INTEGER             HASHT1,      MAXHT1,      PRIME1
C
      COMMON / COM22  /   HASHT1(265), MAXHT1,      PRIME1
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM23  /
C
      INTEGER             HASHT2,      MAXHT2,      PRIME2
C
      COMMON / COM23  /   HASHT2(75),  MAXHT2,      PRIME2
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM24  /
C
      INTEGER             FIND,        LOCATE,      SCAN
C
      COMMON / COM24  /   FIND,        LOCATE,      SCAN
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM25  /
C
      INTEGER             DEFINE,      DOCASE,      DOFOR,       DOWITH
      INTEGER             ELSEIF,      FOREVR,      IFELSE,      IFTHEN
      INTEGER             ONCE,        PROC,        UNTIL,       WHILE
C
      COMMON / COM25  /   DEFINE,      DOCASE,      DOFOR,       DOWITH
      COMMON / COM25  /   ELSEIF,      FOREVR,      IFELSE,      IFTHEN
      COMMON / COM25  /   ONCE,        PROC,        UNTIL,       WHILE
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM27  /
C
      INTEGER             LNAME,       LNAMES,      MAXTAB,      MNAMES
      INTEGER             NAMENO,      NAMTAB,      NNAMES,      USES
      INTEGER             DEFS
C
      COMMON / COM27  /   LNAME,       LNAMES(299), MAXTAB,      MNAMES
      COMMON / COM27  /   NAMENO,      NAMTAB(2099),NNAMES
      COMMON / COM27  /   USES(299),   DEFS(299)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM28  /
C
      INTEGER             MCALLS,      NCALLS,      NAMNOS,      SCALLS
C
      COMMON / COM28  /   MCALLS,      NCALLS,      NAMNOS(599)
      COMMON / COM28  /   SCALLS(599)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM29  /
C
      INTEGER             LABELS,      LBLPTR,      MAXLAB
C
      COMMON / COM29  /   LABELS(199), LBLPTR(39,2),MAXLAB
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM31  /
C
      INTEGER             NS,          NSMAX,       STMT
C
      COMMON / COM31  /   NS,          NSMAX,       STMT(1326)
C
C
C     ********** This is used only in COREIO and BLKDAT **********
C
C     Installation on a host which does not save local  variables
C     across calls revealed that  several locals are expected  to
C     be preserved.  A  FORTRAN 77 SAVE  statement would  suffice
C     for this, but to ensure correct operation under FORTRAN 66,
C     we place these in unique COMMON blocks named SAVnn.  It  is
C     conceivable, but  unlikely, that  it  may be  necessary  to
C     place a copy of this COMMON in the MAIN program.
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / SAV02  /
C
      INTEGER             CORE,        LSTUSE,      MODE,        RECCOR
      INTEGER             RECPOS,      RECMAX
      LOGICAL             ISOPEN
      COMMON / SAV02  /   CORE(40000), LSTUSE,      MODE,        ISOPEN
      COMMON / SAV02  /   RECCOR,      RECPOS,      RECMAX
C
C
C -------- M A C H I N E - I N D E P E N D E N T   S E C T I O N--------
C
C     CASE statement selector symbolic constants
C
      DATA                DEFINE    / 11 /
      DATA                DOCASE    / 8 /
      DATA                DOFOR     / 5 /
      DATA                DOWITH    / 6 /
      DATA                ELSEIF    / 12 /
      DATA                FOREVR    / 9 /
      DATA                IFELSE    / 2 /
      DATA                IFTHEN    / 1 /
      DATA                ONCE      / 10 /
      DATA                PROC      / 4 /
      DATA                UNTIL     / 7 /
      DATA                WHILE     / 3 /
C
C     Search function selector constants
C
      DATA                FIND      / 2 /
      DATA                LOCATE    / 3 /
      DATA                SCAN      / 1 /
C
      DATA                NONE      / -1 /
C
C     LBASE,SBASE,PBASE,P2BASE -- Starting values of statement
C                                 numbers generated by the
C                                 preprocessor
C
      DATA                SPACES    / 3 /
      DATA                LBASE     / 10000 /
      DATA                SBASE     / 20000 /
      DATA                PBASE     / 30000 /
      DATA                P2BASE    / 31000 /
C
C     NSMAX -- Maximum number of characters/statement, plus 2.
C
      DATA                BYTE      / 1H- /
      DATA                NSMAX     / 1328 /
C
      DATA                MLABL     / 40 /
      DATA                LBLPTR(1,1)    /  1 /
C
C     The following values are chosen to be unique integer values
C     to permit a global text substitution to easily change them.
C
C     MAXIN-----Maximum length of input statement line.
C     MAXLAB----Dimension of LABELS(*).
C     MAXLEV----Maximum nesting depth, and dimension of CASES(*),
C               CYCLES(*), EXITS(*), L1STAK(*), OTHERS(*), S1STAK(*).
C     MAXTAB----Dimension of NAMTAB(*).
C     MCALLS----Dimension of SCALLS(*) and NAMNOS(*).
C     MINDX-----Maximum number of characters in structure label,
C               and dimension of INDEXS(*,MAXLEV) and of
C               INDEKS(*) in routine SRSTAK.
C     MNAMES----Dimension  of LNAMES(*),  USES(*), LABELS(*), DEFS(*),
C               and LINES(2,*).
C
      DATA                MAXIN     / 72 /
      DATA                MAXLEV    / 39 /
      DATA                MAXLAB    / 199 /
      DATA                MAXTAB    / 2099 /
      DATA                MCALLS    / 599 /
      DATA                MINDX     / 38 /
      DATA                MNAMES    / 299 /
C
C     CASE statement selector symbolic constants
C
      DATA                ERROUT    / 4 /
      DATA                F4OUT     / 3 /
      DATA                INPUT     / 1 /
      DATA                SFOUT     / 2 /
C
C     Hash table parameters
C
      DATA                MAXHT1    / 265 /
      DATA                MAXHT2    / 75 /
      DATA                PRIME1    / 47 /
      DATA                PRIME2    / 17 /
      DATA                MAXOUT    / 120 /
C
C     Initial parameters for COREIO.
C
      DATA                LSTUSE    / 0 /
      DATA                MODE      / 0 /
      DATA                RECCOR    / 0 /
      DATA                RECPOS    / 0 /
      DATA                RECMAX    / 0 /
      DATA                ISOPEN    / .FALSE. /
C
C ----------M A C H I N E - D E P E N D E N T   S E C T I O N-----------
C
C#if _OS_TOPS20
C##      DATA                WDSIZE    / 5 /
C#else
      DATA                WDSIZE    / 4 /
C#endif
C
C     I/O file unit number assignments
C
C     For  Unix, use 5 and 6 for INSF and OUTF4, since  these are
C     pre-assigned to stdin and stdout, and it is  convenient  to
C     have  them redirectable for command pipelining.   OUTERR is
C     set to 0 (stderr) so that it will come out on the terminal.
C
      DATA                HOLDIO    / 10 /
      DATA                ININCL    / 11 /
      DATA                INSF      / 5 /
C#if _OS_UNIX
      DATA                OUTERR    / 0 /
      DATA                OUTF4     / 6 /
C#else
C##      DATA                OUTERR    / 15 /
C##      DATA                OUTF4     / 14 /
C#endif
      DATA                OUTSF     / 12 /
      DATA                TEMPF4    / 13 /
C
      END
