      SUBROUTINE  GLOGRW
C     (GLOGRW)
C     PROCEDURE (Generate Logic-Setting for READ/WRITE)
C     (23-OCT-84)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       ADDBUF,      ATTNOF,      GOTOS2,      IOFUNC
C     EXTERNAL REFS       OPNCNT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                I,           J
C
      INTEGER             I,           J
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM02  /
C
      INTEGER             CCFLGS,      CCLIST,      CCNAME,      CCRW
      INTEGER             DEFNO,       INDEXS,      LFLGS,       LLIST
      INTEGER             LLOGS,       MAXLEV,      NEXT
C
      COMMON / COM02  /   CCFLGS(2),   CCLIST,      CCNAME,      CCRW
      COMMON / COM02  /   DEFNO,       INDEXS(38,39)
      COMMON / COM02  /   LFLGS(2),    LLIST,       LLOGS(2)
      COMMON / COM02  /   MAXLEV,      NEXT
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM03  /
C
      INTEGER             CASES,       CCINDX,      CCLOG,       CCLOGS
      INTEGER             LINDX,       LLOG
      INTEGER             MINDX,       NFND,        NONE
      INTEGER             NSTACK,      S1STAK,      SFNMBR
      LOGICAL             BLANK,       FOUND,       NOFLOW,      NONMBR
      LOGICAL             XLATED
C
      COMMON / COM03  /   BLANK,       CASES(39),   CCINDX,      CCLOG
      COMMON / COM03  /   CCLOGS(2),   FOUND,       LINDX
      COMMON / COM03  /   LLOG,        MINDX
      COMMON / COM03  /   NFND,        NOFLOW,      NONE,        NONMBR
      COMMON / COM03  /   NSTACK,      S1STAK(39),  SFNMBR
      COMMON / COM03  /   XLATED
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM05  /
C
      INTEGER             BLANKS,      LEFT,        LEVEL
      INTEGER             RIGHT,       S0,          S1,          STRCTS
      COMMON / COM05  /   BLANKS(92),  LEFT,        LEVEL
      COMMON / COM05  /   RIGHT,       S0,          S1
      COMMON / COM05  /   STRCTS(39)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM07  /
C
      INTEGER             S1PNDG,      S2
      LOGICAL             EXITS,       FND,         OTHERS
C
      COMMON / COM07  /   EXITS(39),   FND,         OTHERS(39),  S1PNDG
      COMMON / COM07  /   S2
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM17  /
C
      INTEGER             ERROUT,      F4OUT,       INPUT,       SFOUT
C
      COMMON / COM17  /   ERROUT,      F4OUT,       INPUT,       SFOUT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM30  /
C
      INTEGER             NB,          BUFFER
C
      COMMON / COM30  /   NB,          BUFFER(1326)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM31  /
C
      INTEGER             NS,          NSMAX,       STMT
C
      COMMON / COM31  /   NS,          NSMAX,       STMT(1326)
C
C
      I=1
      N20001=NFND
      GO TO 20002
20001 I=I+1
20002 IF ((N20001-I).LT.0) GO TO 20003
      ASSIGN 20005 TO NPR001
      GO TO 30001
20005 GO TO 20001
20003 J=1
      N20006=NFND
      GO TO 20007
20006 J=J+1
20007 IF ((N20006-J).LT.0) GO TO 20008
      ASSIGN 20010 TO NPR002
      GO TO 30002
20010 I=1
      N20011=NFND
      GO TO 20012
20011 I=I+1
20012 IF ((N20011-I).LT.0) GO TO 20013
      IF (.NOT.(I.EQ.1)) GO TO 20015
      S1=S0+J
      GO TO 20016
20015 S1=0
20016 CONTINUE
20017 IF (.NOT.(I.EQ.J)) GO TO 20018
      ASSIGN 20021 TO NPR003
      GO TO 30003
20021 GO TO 20019
20018 ASSIGN 20022 TO NPR001
      GO TO 30001
20022 CONTINUE
20019 GO TO 20011
20013 GO TO 20006
20008 S1=S2
      ASSIGN 20023 TO NPR004
      GO TO 30004
20023 S1PNDG=S1
C
      RETURN
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Attach Number to Generated FORTRAN Statement)
30005 CALL ATTNOF
      GO TO NPR005, (20024,20025)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate 'GO TO S2')
30002 CALL GOTOS2
      GO TO 20010
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate 'S1 LOGIC(I)=.FALSE.')
30001 CALL ADDBUF (BLANKS,1,6)
      CALL ADDBUF (STMT,CCLOGS(I),LLOGS(I))
      CALL ADDBUF (8H=.FALSE.,1,8)
      ASSIGN 20024 TO NPR005
      GO TO 30005
20024 CALL IOFUNC (F4OUT,BUFFER,NB)
      NB=0
      GO TO NPR001, (20005,20022)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate 'S1 LOGIC(I)=.TRUE.')
30003 CALL ADDBUF (BLANKS,1,6)
      CALL ADDBUF (STMT,CCLOGS(I),LLOGS(I))
      CALL ADDBUF (7H=.TRUE.,1,7)
      ASSIGN 20025 TO NPR005
      GO TO 30005
20025 CALL IOFUNC (F4OUT,BUFFER,NB)
      NB=0
      GO TO 20021
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Output 'S1PNDG CONTINUE')
30004 CALL OPNCNT
      GO TO 20023
C
      END
