      SUBROUTINE  HELP
C     (Help Routine)
C     When this routine is invoked, it will copy the contents
C     of the file HLP:SF3.HLP to the TTY: file and return.
C     (05-JUL-79)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       SYSCLS,      SYSOPN
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     HOLLERITH STRING VARIABLES
C
      INTEGER             BLANK
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                EOFILE,      I,           IN,          LENGTH
C     SETS                LINE,        MAXLIN,      OUT
C
      INTEGER             I,           IN,          LENGTH
      INTEGER             LINE(72),    MAXLIN,      OUT
      LOGICAL             EOFILE,      ERROR
C
      DATA                BLANK     / 1H  /
      DATA                IN        / 62 /
      DATA                MAXLIN    / 72 /
      DATA                OUT       / 63 /
C
      ASSIGN 20001 TO NPR001
      GO TO 30001
20001 IF (.NOT.(.NOT.ERROR)) GO TO 20002
      ASSIGN 20005 TO NPR002
      GO TO 30002
20005 CONTINUE
20006 IF (.NOT.(.NOT.EOFILE)) GO TO 20007
      ASSIGN 20008 TO NPR003
      GO TO 30003
20008 ASSIGN 20009 TO NPR002
      GO TO 30002
20009 GO TO 20006
20007 CONTINUE
20002 CONTINUE
20003 ASSIGN 20010 TO NPR004
      GO TO 30004
C
20010 RETURN
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Close Input and Output Files)
30004 CALL SYSCLS (IN)
      CALL SYSCLS (OUT)
      GO TO 20010
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Input a Line)
30002 READ (IN,1000,END=20011) LINE
      EOFILE=.FALSE.
      GO TO 20012
20011 EOFILE=.TRUE.
20012 GO TO NPR002, (20005,20009)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Open Input and Output Files)
30001 CALL SYSOPN (IN ,7HSF3.HLP,4HHLP:,5HSEQIN,5HASCII,4HSAVE,
     XERROR)
      IF (.NOT.ERROR) CALL SYSOPN (OUT,1H ,4HTTY:,6HSEQOUT,
     X5HASCII,4HSAVE,ERROR)
      GO TO 20001
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Output a Line)
30003 LENGTH = MAXLIN
20013 IF (.NOT.((LENGTH .GT. 1) .AND. (LINE(LENGTH) .EQ. BLANK))) GO TO
     X20014
      LENGTH = LENGTH - 1
      GO TO 20013
20014 WRITE (OUT,2000) (LINE(I), I = 1,LENGTH)
      GO TO 20008
C
 1000 FORMAT (72A1)
 2000 FORMAT (1X,72A1)
      END
